Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# gnContigSpec Class Reference

gnContigSpec is an interface for classes which store contigs, or reads, of DNA or protein sequence. More...

`#include <gnContigSpec.h>`

Inheritance diagram for gnContigSpec::

List of all members.

## Public Methods
| gnContigSpec ()
virtual | ~gnContigSpec ()
| Destructor, frees memory. More...
virtual gnContigSpec* | Clone () const=0
virtual gnContigSpec* | CloneRange (const uint32 startI, const uint32 len) const=0
virtual string | GetSourceName () const
| Get the name of the source associated with this spec. More...
virtual gnSeqI | GetStart () const
| Get the base pair index where this contig starts inside of the sequence data. More...
virtual gnSeqI | GetLength () const
| Get the length of this contig inside of the sequence data. More...
virtual gnSeqI | GetSourceLength () const=0
| Get the length of the source for this spec. More...
virtual uint32 | GetSourceContigIndex () const
| Returns this contig's index in its source sequence. More...
virtual void | SetSourceName (const string &sourceName)
| Sets the name of the source associated with this contig. More...
virtual void | SetStart (const gnSeqI start)
| Sets the starting base pair to read from in the contig's sequence. More...
virtual void | SetLength (const gnSeqI len)
| Sets the length of reads into this sequence. More...
virtual void | SetSourceContigIndex (const uint32 contigI)
| Sets this contig's index in its source sequence. More...
virtual void | SetReverseComplement (const boolean value)
| Sets the reverse complement bit for this contig. More...
virtual void | CropStart (gnSeqI cropLen)
| Crop the first cropLen bases from the sequence. More...
virtual void | CropEnd (gnSeqI cropLen)
| Crop the last cropLen bases from the sequence. More...
virtual boolean | SeqRead (const gnSeqI start, gnSeqC *buf, uint32 &bufLen, const uint32 contigI) const
| Reads sequence data from this spec. More...
virtual void | Clear ()
| Clears all data from this spec. More...
## Protected Methods
virtual boolean | Read (const gnSeqI start, gnSeqC *buf, uint32 &bufLen) const=0
| all derived classes must implement this! it simply reads the specified bases into buf, disregarding circularity and reverse complement. More...
## Protected Attributes
gnSeqI | m_start
gnSeqI | m_length
uint32 | m_SourceContigIndex

## Detailed Description

gnContigSpec is an interface for classes which store contigs, or reads, of DNA or protein sequence.

Definition at line 28 of file gnContigSpec.h.

## Constructor & Destructor Documentation

gnContigSpec::gnContigSpec ( | )`[inline]`

| Definition at line 31 of file gnContigSpec.h.

gnContigSpec::~gnContigSpec ( | )`[inline, virtual]`

| Destructor, frees memory. Definition at line 35 of file gnContigSpec.h.

## Member Function Documentation

void gnContigSpec::Clear ( | )`[virtual]`

| Clears all data from this spec. Reimplemented from gnBaseSpec. Reimplemented in gnSourceSpec, and gnStringSpec. Definition at line 61 of file gnContigSpec.cpp. Referenced by gnStringSpec::Clear(), and gnSourceSpec::Clear().

gnContigSpec * gnContigSpec::Clone ( | ) const`[pure virtual]`

| Reimplemented from gnBaseSpec. Reimplemented in gnSourceSpec, and gnStringSpec. Referenced by gnFragmentSpec::CloneRange(), and gnSequence::gnSequence().

gnContigSpec * gnContigSpec::CloneRange ( | const uint32 startI,
| const uint32 len ) const`[pure virtual]`

| Reimplemented from gnBaseSpec. Referenced by gnFragmentSpec::CloneRange().

void gnContigSpec::CropEnd ( | gnSeqI cropLen )`[virtual]`

  | Crop the last cropLen bases from the sequence. CropEnd will delete features and headers associated with the cropped bases. Parameters:
  cropLen | The number of base pairs to delete from the end.
Reimplemented from gnBaseSpec. Definition at line 23 of file gnContigSpec.cpp.

void gnContigSpec::CropStart ( | gnSeqI cropLen )`[virtual]`

  | Crop the first cropLen bases from the sequence. CropStart will delete features and headers associated with the cropped bases. Parameters:
  cropLen | The number of base pairs to delete from the beginning.
Reimplemented from gnBaseSpec. Definition at line 17 of file gnContigSpec.cpp.

gnSeqI gnContigSpec::GetLength ( | ) const`[inline, virtual]`

| Get the length of this contig inside of the sequence data. Returns: This contigs length. Reimplemented from gnBaseSpec. Definition at line 134 of file gnContigSpec.h. Referenced by gnFragmentSpec::CloneRange(), gnSEQSource::ParseStream(), and gnGBKSource::ParseStream().

uint32 gnContigSpec::GetSourceContigIndex ( | ) const`[inline, virtual]`

| Returns this contig's index in its source sequence. Returns: This contig's index in the source sequence. Definition at line 150 of file gnContigSpec.h. Referenced by gnSequence::globalToSource().

gnSeqI gnContigSpec::GetSourceLength ( | ) const`[pure virtual]`

| Get the length of the source for this spec. Returns: The source length. Reimplemented in gnSourceSpec, and gnStringSpec. Referenced by CropStart(), SeqRead(), SetReverseComplement(), and gnSequence::globalToSource().

string gnContigSpec::GetSourceName ( | ) const`[inline, virtual]`

| Get the name of the source associated with this spec. Returns: The source name or an empty string if none exists. Definition at line 120 of file gnContigSpec.h.

gnSeqI gnContigSpec::GetStart ( | ) const`[inline, virtual]`

| Get the base pair index where this contig starts inside of the sequence data. Returns: The starting base pair. Definition at line 129 of file gnContigSpec.h. Referenced by gnSequence::globalToSource().

boolean gnContigSpec::Read ( | const gnSeqI start,
| gnSeqC * buf,
| uint32 & bufLen ) const`[protected, pure virtual]`

| all derived classes must implement this! it simply reads the specified bases into buf, disregarding circularity and reverse complement. Reimplemented in gnSourceSpec, and gnStringSpec. Referenced by SeqRead().

boolean gnContigSpec::SeqRead ( | const gnSeqI start,
| gnSeqC * buf,
| uint32 & bufLen,
| const uint32 contigI ) const`[virtual]`

  | Reads sequence data from this spec. SeqRead will attempt to read "bufLen" base pairs starting at "start", an offset into the sequence. Reading inside a specific contig can be accomplished by supplying the "contigI" parameter with a valid contig index. SeqRead stores the sequence data in "buf" and returns the actual number of bases read in "bufLen". SeqRead will return false if a serious error occurs. Parameters:
  start | The base pair to start reading at.
  buf | The character array to store base pairs into.
  bufLen | The number of base pairs to read. This will be modified to reflect the actual number of bases read.
  contigI | The index of the subspec to read or ALL_CONTIGS by default.
Returns: True if the operation was successful. Reimplemented from gnBaseSpec. Definition at line 35 of file gnContigSpec.cpp.

void gnContigSpec::SetLength ( | const gnSeqI len )`[inline, virtual]`

  | Sets the length of reads into this sequence. This does not affect the actual sequence data but only how much of it is used in this contig. Parameters:
  len | The new sequence length.
Returns: True if successful. Definition at line 145 of file gnContigSpec.h. Referenced by gnSEQSource::ParseStream(), and gnGBKSource::ParseStream().

void gnContigSpec::SetReverseComplement ( | const boolean value )`[virtual]`

  | Sets the reverse complement bit for this contig. This routine will translate the start index to the reverse base pair. Parameters:
  value | True for reverse complement, false otherwise.
Returns: True if successful. Reimplemented from gnBaseSpec. Definition at line 27 of file gnContigSpec.cpp. Referenced by gnFragmentSpec::SetReverseComplement().

void gnContigSpec::SetSourceContigIndex ( | const uint32 contigI )`[inline, virtual]`

  | Sets this contig's index in its source sequence. Parameters:
  This | contig's index in the source sequence.
Definition at line 154 of file gnContigSpec.h.

void gnContigSpec::SetSourceName ( | const string & sourceName )`[inline, virtual]`

  | Sets the name of the source associated with this contig. Parameters:
  sourceName | The new name.
Returns: True if successful. Definition at line 124 of file gnContigSpec.h. Referenced by gnFASSource::GetSpec(), gnSEQSource::ParseStream(), gnRAWSource::ParseStream(), gnGBKSource::ParseStream(), and gnDNXSource::ParseStream().

void gnContigSpec::SetStart ( | const gnSeqI start )`[inline, virtual]`

  | Sets the starting base pair to read from in the contig's sequence. This does not affect the actual sequence data but only where to begin using it in this contig. Parameters:
  start | The new starting base pair.
Returns: True if successful. Definition at line 140 of file gnContigSpec.h.

## Member Data Documentation

uint32 gnContigSpec::m_SourceContigIndex`[protected]`

| Definition at line 106 of file gnContigSpec.h.

gnSeqI gnContigSpec::m_length`[protected]`

| Definition at line 105 of file gnContigSpec.h.

gnSeqI gnContigSpec::m_start`[protected]`

| Definition at line 104 of file gnContigSpec.h.

The documentation for this class was generated from the following files:

- gnContigSpec.h
- gnContigSpec.cpp